﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Assignment10.OB;

namespace Assignment10.UI
{
    public partial class frmMain : Form
    {
        private List<CCustomer> _customerList;
        private CCustomer Customer1;
        private CCustomer Customer2;
        private CCustomer Customer3;

        private bool ColumnsRemoved;

        public List<CCustomer> CustomerList
        {
            get { return _customerList; }
            set { _customerList = value; }
        }

        public frmMain()
        {
            InitializeComponent();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            // Fake loading data from a file
            GetFakeDataFile();

            PopulateControls();
        }

        private void GetFakeDataFile()
        {
            // Fill in basic customer data
            #region FillInCustomerDate
            CCustomer oCustomer1 = new OB.CCustomer();
            CCustomer oCustomer2 = new OB.CCustomer();
            CCustomer oCustomer3 = new OB.CCustomer();

            oCustomer1.ID = 2358304;
            oCustomer1.FirstName = "Steve";
            oCustomer1.LastName = "Irwin";
            oCustomer1.FullName = "Steve Irwin";
            oCustomer1.SSN = "547-34-9604";
            oCustomer1.BirthDate = "6/13/60";

            oCustomer2.ID = 5960384;
            oCustomer2.FirstName = "Bob";
            oCustomer2.LastName = "Barker";
            oCustomer2.FullName = "Bob Barker";
            oCustomer2.SSN = "302-39-4039";
            oCustomer2.BirthDate = "7/9/44";

            oCustomer3.ID = 9669839;
            oCustomer3.FirstName = "Ady";
            oCustomer3.LastName = "Gil";
            oCustomer3.FullName = "Ady Gil";
            oCustomer3.SSN = "903-52-3049";
            oCustomer3.BirthDate = "3/11/77";
            #endregion

            // Fill in customer transactions
            #region FillInCustomerTransactions
            CTransaction oTransaction01 = new OB.CTransaction();
            CTransaction oTransaction02 = new OB.CTransaction();
            CTransaction oTransaction03 = new OB.CTransaction();
            CTransaction oTransaction04 = new OB.CTransaction();
            CTransaction oTransaction05 = new OB.CTransaction();
            CTransaction oTransaction06 = new OB.CTransaction();

            CTransaction oTransaction11 = new OB.CTransaction();
            CTransaction oTransaction12 = new OB.CTransaction();
            CTransaction oTransaction13 = new OB.CTransaction();
            CTransaction oTransaction14 = new OB.CTransaction();
            CTransaction oTransaction15 = new OB.CTransaction();
            CTransaction oTransaction16 = new OB.CTransaction();

            CTransaction oTransaction21 = new OB.CTransaction();
            CTransaction oTransaction22 = new OB.CTransaction();
            CTransaction oTransaction23 = new OB.CTransaction();
            CTransaction oTransaction24 = new OB.CTransaction();
            CTransaction oTransaction25 = new OB.CTransaction();
            CTransaction oTransaction26 = new OB.CTransaction();

            List<CTransaction> TempTransactionList1 = new List<CTransaction>();
            List<CTransaction> TempDepositList1 = new List<CTransaction>();
            List<CTransaction> TempWithdrawalList1 = new List<CTransaction>();

            List<CTransaction> TempTransactionList2 = new List<CTransaction>();
            List<CTransaction> TempDepositList2 = new List<CTransaction>();
            List<CTransaction> TempWithdrawalList2 = new List<CTransaction>();

            List<CTransaction> TempTransactionList3 = new List<CTransaction>();
            List<CTransaction> TempDepositList3 = new List<CTransaction>();
            List<CTransaction> TempWithdrawalList3 = new List<CTransaction>();

            List<CCustomer> TempCustomerList = new List<CCustomer>();

            oTransaction01.TransID = 100;
            oTransaction01.TransAmount = 493.93;
            oTransaction01.TransType = "Deposit";
            oTransaction01.TransDate = "4/10/11";
            TempTransactionList1.Add(oTransaction01);
            TempDepositList1.Add(oTransaction01);

            oTransaction02.TransID = 101;
            oTransaction02.TransAmount = -49.23;
            oTransaction02.TransType = "Withdrawal";
            oTransaction02.TransDate = "4/11/11";
            TempTransactionList1.Add(oTransaction02);
            TempWithdrawalList1.Add(oTransaction02);

            oTransaction03.TransID = 102;
            oTransaction03.TransAmount = 105.39;
            oTransaction03.TransType = "Deposit";
            oTransaction03.TransDate = "4/12/11";
            TempTransactionList1.Add(oTransaction03);
            TempDepositList1.Add(oTransaction03);

            oTransaction04.TransID = 103;
            oTransaction04.TransAmount = 430.59;
            oTransaction04.TransType = "Deposit";
            oTransaction04.TransDate = "4/13/11";
            TempTransactionList1.Add(oTransaction04);
            TempDepositList1.Add(oTransaction04);

            oTransaction05.TransID = 104;
            oTransaction05.TransAmount = -660.39;
            oTransaction05.TransType = "Withdrawal";
            oTransaction05.TransDate = "4/14/11";
            TempTransactionList1.Add(oTransaction05);
            TempWithdrawalList1.Add(oTransaction05);

            oTransaction06.TransID = 105;
            oTransaction06.TransAmount = -49.24;
            oTransaction06.TransType = "Withdrawal";
            oTransaction06.TransDate = "4/15/11";
            TempTransactionList1.Add(oTransaction06);
            TempWithdrawalList1.Add(oTransaction06);

            // Add customer
            oCustomer1.TransactionList = TempTransactionList1;
            oCustomer1.WithdrawalList = TempWithdrawalList1;
            oCustomer1.DepositList = TempDepositList1;
            Customer1 = oCustomer1;
            TempCustomerList.Add(oCustomer1);
            TempTransactionList1 = null;

            oTransaction11.TransID = 200;
            oTransaction11.TransAmount = -2495.38;
            oTransaction11.TransType = "Withdrawal";
            oTransaction11.TransDate = "4/10/11";
            TempTransactionList2.Add(oTransaction11);
            TempWithdrawalList2.Add(oTransaction11);

            oTransaction12.TransID = 201;
            oTransaction12.TransAmount = 1905.49;
            oTransaction12.TransType = "Deposit";
            oTransaction12.TransDate = "4/11/11";
            TempTransactionList2.Add(oTransaction12);
            TempDepositList2.Add(oTransaction12);

            oTransaction13.TransID = 202;
            oTransaction13.TransAmount = 6043.29;
            oTransaction13.TransType = "Deposit";
            oTransaction13.TransDate = "4/12/11";
            TempTransactionList2.Add(oTransaction13);
            TempDepositList2.Add(oTransaction13);

            oTransaction14.TransID = 203;
            oTransaction14.TransAmount = -5593.34;
            oTransaction14.TransType = "Withdrawal";
            oTransaction14.TransDate = "4/13/11";
            TempTransactionList2.Add(oTransaction14);
            TempWithdrawalList2.Add(oTransaction14);

            oTransaction15.TransID = 204;
            oTransaction15.TransAmount = -5993.65;
            oTransaction15.TransType = "Withdrawal";
            oTransaction15.TransDate = "4/14/11";
            TempTransactionList2.Add(oTransaction15);
            TempWithdrawalList2.Add(oTransaction15);

            oTransaction16.TransID = 205;
            oTransaction16.TransAmount = 4349.69;
            oTransaction16.TransType = "Deposit";
            oTransaction16.TransDate = "4/15/11";
            TempTransactionList2.Add(oTransaction16);
            TempDepositList2.Add(oTransaction16);

            // Add customer
            oCustomer2.TransactionList = TempTransactionList2;
            oCustomer2.WithdrawalList = TempWithdrawalList2;
            oCustomer2.DepositList = TempDepositList2;
            Customer2 = oCustomer2;
            TempCustomerList.Add(oCustomer2);
            TempTransactionList2 = null;

            oTransaction21.TransID = 300;
            oTransaction21.TransAmount = 504.22;
            oTransaction21.TransType = "Deposit";
            oTransaction21.TransDate = "4/10/11";
            TempTransactionList3.Add(oTransaction21);
            TempDepositList3.Add(oTransaction21);

            oTransaction22.TransID = 301;
            oTransaction22.TransAmount = 794.31;
            oTransaction22.TransType = "Deposit";
            oTransaction22.TransDate = "4/11/11";
            TempTransactionList3.Add(oTransaction22);
            TempDepositList3.Add(oTransaction22);

            oTransaction23.TransID = 302;
            oTransaction23.TransAmount = -506.33;
            oTransaction23.TransType = "Withdrawal";
            oTransaction23.TransDate = "4/12/11";
            TempTransactionList3.Add(oTransaction23);
            TempWithdrawalList3.Add(oTransaction23);

            oTransaction24.TransID = 303;
            oTransaction24.TransAmount = 994.44;
            oTransaction24.TransType = "Deposit";
            oTransaction24.TransDate = "4/13/11";
            TempTransactionList3.Add(oTransaction24);
            TempDepositList3.Add(oTransaction24);

            oTransaction25.TransID = 304;
            oTransaction25.TransAmount = -5593.39;
            oTransaction25.TransType = "Withdrawal";
            oTransaction25.TransDate = "4/14/11";
            TempTransactionList3.Add(oTransaction25);
            TempWithdrawalList3.Add(oTransaction25);

            oTransaction26.TransID = 305;
            oTransaction26.TransAmount = -1493.55;
            oTransaction26.TransType = "Withdrawal";
            oTransaction26.TransDate = "4/15/11";
            TempTransactionList3.Add(oTransaction26);
            TempWithdrawalList3.Add(oTransaction26);

            // Add customer
            oCustomer3.TransactionList = TempTransactionList3;
            oCustomer3.WithdrawalList = TempWithdrawalList3;
            oCustomer3.DepositList = TempDepositList3;
            Customer3 = oCustomer3;
            TempCustomerList.Add(oCustomer3);
            TempTransactionList3 = null;

            // Add customers
            CustomerList = TempCustomerList;
            #endregion
        }

        private void PopulateControls()
        {
            foreach (CCustomer c in CustomerList)
            {
                lstCustomerList.Items.Add(c.FullName);
            }

            lstCustomerList.SelectedIndex = 0;
        }

        private void lstCustomerList_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (lstCustomerList.SelectedIndex == 0)
            {
                lblFirstName.Text = Customer1.FirstName;
                lblLastName.Text = Customer1.LastName;
                lblSSN.Text = Customer1.SSN;
                lblID.Text = Customer1.ID.ToString();
                lblBirthDate.Text = Customer1.BirthDate;

                dtgAllTransactions.DataSource = Customer1.TransactionList;
                dtgDeposits.DataSource = Customer1.DepositList;
                dtgWithdrawals.DataSource = Customer1.WithdrawalList;
            }
            else if (lstCustomerList.SelectedIndex == 1)
            {
                lblFirstName.Text = Customer2.FirstName;
                lblLastName.Text = Customer2.LastName;
                lblSSN.Text = Customer2.SSN;
                lblID.Text = Customer2.ID.ToString();
                lblBirthDate.Text = Customer2.BirthDate;

                dtgAllTransactions.DataSource = Customer2.TransactionList;
                dtgDeposits.DataSource = Customer2.DepositList;
                dtgWithdrawals.DataSource = Customer2.WithdrawalList;
            }
            else if (lstCustomerList.SelectedIndex == 2)
            {
                lblFirstName.Text = Customer3.FirstName;
                lblLastName.Text = Customer3.LastName;
                lblSSN.Text = Customer3.SSN;
                lblID.Text = Customer3.ID.ToString();
                lblBirthDate.Text = Customer3.BirthDate;

                dtgAllTransactions.DataSource = Customer3.TransactionList;
                dtgDeposits.DataSource = Customer3.DepositList;
                dtgWithdrawals.DataSource = Customer3.WithdrawalList;
            }
            else
            {
                lstCustomerList.SelectedIndex = 0;
            }

            dtgAllTransactions.Columns["TransID"].DisplayIndex = 0;
            dtgAllTransactions.Columns["TransType"].DisplayIndex = 1;
            dtgAllTransactions.Columns["TransAmount"].DisplayIndex = 2;
            dtgAllTransactions.Columns["TransDate"].DisplayIndex = 3;

            if (ColumnsRemoved == false)
            {
                dtgDeposits.Columns["TransType"].Visible = false;
                dtgWithdrawals.Columns["TransType"].Visible = false;
            }

            ColumnsRemoved = true;
        }

        private void btnAllTransactions_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedTab = tabPage1;
        }

        private void btnDeposits_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedTab = tabPage2;
        }

        private void btnWithdrawals_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedTab = tabPage3;
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}
